// gcc THISFILE.c -O3 -s -o vwheeld -l pthread
#include <unistd.h>
#include <string.h>
#include <limits.h>
#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <linux/inotify.h>


#define EVENT_BUF_LEN     (10 * (sizeof(struct inotify_event) + NAME_MAX + 1) )
#define PCMPATH "/dev/snd/pcmC0D0p"
#define PCMPATH1 "/dev/snd/pcmC1D0p"
#define PCMPATH2 "/dev/snd/pcmC2D0p"
#define PCMPATH3 "/dev/snd/pcmC3D0p"
#define PCMPATH4 "/dev/snd/pcmC4D0p"
#define POLLTIME 100000 //0.1s
#define SLOWPOLLTIME 2000000 //2s
#define TIMEOUT 15
#define WHEELRANGE 2000
#define COMMSIZE 55

unsigned int Delay = POLLTIME;
unsigned int Orginaldelay = POLLTIME;
unsigned int Slowdelay = SLOWPOLLTIME;
int Hhandle;
char Buffer[EVENT_BUF_LEN];
pthread_t Moni;
pthread_t Tim;
int Timeout=TIMEOUT;
char Stat=0;
char Pollstat=0;
char Timestat=0;
char Stayon=0;
int Value;
int OldValue=-2;
int Pro=0;
int Oldpro=-2;
int Offset=19;
FILE *File;
char Command[COMMSIZE];
char Commanduser[COMMSIZE]="pactl set-sink-volume 0 %i%%";
int Wheelrange=WHEELRANGE/100;

void *Timer(){
 sleep(Timeout);
 Delay = Slowdelay;
// printf( "End Timer\n");
 Timestat=0;	
}

void *Tik(){
 while(Stat){
  fscanf(File,"%d", &Value);
  fseek(File, 0L, SEEK_SET);
 // printf( "Read value:%i\n",Value );
  if (Value!=OldValue){
   OldValue=Value;
   Pro= (Offset+Value)/Wheelrange; //this should be Value^0.6-1 for an optimal scaling.
  // printf( "Compare percentage:%i to %i\n",Pro,Oldpro);
   if (abs(Pro-Oldpro)>1){
    snprintf(Command, COMMSIZE,Commanduser, abs(Pro)); //UUUUGLYYYY but still better than compiling against pulse.
    system(Command);
    Oldpro=Pro;
   // printf( "Changed volume to:%i\n",abs(Pro) );
   }
  }
  usleep(Delay);
 }
 Pollstat=0;
// printf( "End poll\n");
}


void *Tik2(){
 while(Stat){
  fscanf(File,"%d", &Value);
  fseek(File, 0L, SEEK_SET);
 // printf( "Read value:%i\n",Value );
  if (Value!=OldValue){
   OldValue=Value;
   Pro= (Offset+Value)/Wheelrange; 
  // printf( "Compare percentage:%i to %i\n",Pro,Oldpro);
   if (abs(Pro-Oldpro)>1){
    snprintf(Command, COMMSIZE, Commanduser, abs(Pro)); 
    system(Command);
    Oldpro=Pro;
   // printf( "Changed volume to:%i\n",Pro );
    if (!Timestat){
     Delay = Orginaldelay;
    // printf( "Start Timer\n");
     pthread_create (&Tim, NULL, Timer, NULL);
     Timestat=1;
    }  
   }
  }
  usleep(Delay);
 }
 Pollstat=0;
// printf( "End poll\n");
}

void Openwheel(){
 if (fopen("/sys/bus/iio/devices/iio:device3/in_voltage2_input", "r")){ 
 File= fopen ("/sys/bus/iio/devices/iio:device3/in_voltage2_raw", "r");}
 else if(fopen("/sys/bus/iio/devices/iio:device4/in_voltage2_input", "r")){ 
 File= fopen ("/sys/bus/iio/devices/iio:device4/in_voltage2_raw", "r");}
 else if(fopen("/sys/bus/iio/devices/iio:device2/in_voltage2_input", "r")){ 
 File= fopen ("/sys/bus/iio/devices/iio:device2/in_voltage2_raw", "r");}
 else if(fopen("/sys/bus/iio/devices/iio:device1/in_voltage2_input", "r")){ 
 File= fopen ("/sys/bus/iio/devices/iio:device1/in_voltage2_raw", "r");}
 else if(fopen("/sys/bus/iio/devices/iio:device0/in_voltage2_input", "r")){ 
 File= fopen ("/sys/bus/iio/devices/iio:device0/in_voltage2_raw", "r");}
 setvbuf(File, NULL, _IONBF, 0);
}


void main(int argc, char *argv[]){
 Openwheel();
 int jj;
 for (jj=1; jj < argc; jj++) {
  if (!strcmp(argv[jj], "Speed")){ 
   Delay = atoi(argv[jj+1]);
   Orginaldelay=Delay;
  }
  else if (!strcmp(argv[jj], "Range")){ 
   Wheelrange = atoi(argv[jj+1])/100;
  }
  else if (!strcmp(argv[jj], "Timeout")){ 
   Timeout = atoi(argv[jj+1]);
  }
  else if (!strcmp(argv[jj], "Slow")){ 
   Slowdelay = atoi(argv[jj+1]);
  }
  else if (!strcmp(argv[jj], "Offset")){ 
   Offset = atoi(argv[jj+1]);
  }
  else if (!strcmp(argv[jj], "Stayon")){ 
   Stayon = 1;
  }
  else if (!strcmp(argv[jj], "Command")){ 
   strcpy(Commanduser, argv[jj+1]);
  }
  else if (!strcmp(argv[jj], "Help") || !strcmp(argv[jj], "help") || !strcmp(argv[jj], "h") || !strcmp(argv[jj], "-h") ){ 
   printf( "Volumewheel monitor, list of arguments:\n" );
   printf( "Speed     Delay between polling wheel in μs\n" );
   printf( "          Advised value: 100000 (0.1s)\n" );
   printf( "          Default value: %i \n", Delay );
   printf( "Range     Expected Maximal wheel value, default: %i\n", WHEELRANGE );
   printf( "          Higher values limit the volume, lower allow an overdrive\n" );
   printf( "          Eg: 4000> 50%% max volume; 1000> 200%% max volume\n");
   printf( "Timout    Time in seconds after polltime should be reduced to second value\n");
   printf( "          Disabled when 0, Default: %i\n", Timeout );
   printf( "Slow      Same as Speed, applied after Timout seconds\n" );
   printf( "          Advised value: 1000000 (1s)\n" );
   printf( "          Default value: %i\n",Slowdelay );
   printf( "Offset    Adjust starting point of wheel\n" );
   printf( "          A negative value of 2041 effectively reverses the wheel direction" );
   printf( "          Default value: %i\n",Offset );
   printf( "Command   Custom terminal command to use. %%i is used to gather the percentage.\n" );
   printf( "          Example to use alsa instead pulse: \"amixer set Master %%i\"\n" );
   printf( "          Scaling behaviour of amixer differs, use Range to adjust\n" );
   printf( "          Default value: \"pactl set-sink-volume 0 %%i%%\"\n" );
   printf( "Stayon    Disables monitor of Soundcard, never turn polling off\n" );
   printf( "Help      This page oviously\n\n" );
   printf( "Example: Poll very fast after sound starts playing and then every two seconds after the first 10 seconds:\n" );
   printf( "vwheeld Speed 20000 Timeout 10 Slow 2000000 \n" );
   printf( "Example: Always poll slow, no monitoring, limit volume to 50%%\n");
   printf( "vwheeld Speed 1000000 Timeout 0 Stayon Range 4000 \n" );
   printf( "Example: Bind wheel to top Led\n");
   printf( "vwheeld Command \"echo %%i >/sys/class/leds/logo:red:top/brightness\" Timeout 5 Stayon Range 1000 \n" );
   printf( "No waranty for unexpected behaviour when used with wrong values\n" );
   exit(1);
  }
 } 
 if (!Timeout && Stayon){
  Stat=1; 
 // printf( "Start Polling without monitor.\n");
  Tik();
 }
 Hhandle = inotify_init();	
 inotify_add_watch( Hhandle,PCMPATH, IN_OPEN | IN_CLOSE_WRITE  ); 
 inotify_add_watch( Hhandle,PCMPATH1, IN_OPEN | IN_CLOSE_WRITE  ); 
 inotify_add_watch( Hhandle,PCMPATH2, IN_OPEN | IN_CLOSE_WRITE  ); 
 inotify_add_watch( Hhandle,PCMPATH3, IN_OPEN | IN_CLOSE_WRITE  ); 
 inotify_add_watch( Hhandle,PCMPATH4, IN_OPEN | IN_CLOSE_WRITE  ); 
 //much if, so wow, very code
 if (!Timeout && !Stayon){
  while (read( Hhandle, Buffer, EVENT_BUF_LEN )){
   if (Buffer[4]==32){
    Stat=1;
    if (!Pollstat){
    // printf( "Start Polling\n");
     pthread_create (&Moni, NULL, Tik, NULL);
     Pollstat=1;
    }  
   }
   else{   
   // printf( "Shutting down\n");
    Stat=0;
   }
  }
 }
 else if (Timeout && !Stayon){
  while (read( Hhandle, Buffer, EVENT_BUF_LEN )){
   if (Buffer[4]==32){
    Stat=1;
    if (!Pollstat){
    // printf( "Start Polling with timeout\n");
     pthread_create (&Moni, NULL, Tik2, NULL);
     Pollstat=1;
    }  
    if (!Timestat){
     Delay = Orginaldelay;
    // printf( "Start Timer\n");
     pthread_create (&Tim, NULL, Timer, NULL);
     Timestat=1;
    }  
   }
   else{   
  // printf( "Shutting down\n");
   Stat=0;
   }
  }
 }
 else if (Timeout && Stayon){
  Stat=1; 
 // printf( "Start Polling with monitor, never shutdown\n");
  pthread_create (&Moni, NULL, Tik2, NULL);
 // printf( "Start Timer\n");
  pthread_create (&Tim, NULL, Timer, NULL);
  Timestat=1;
  while (read( Hhandle, Buffer, EVENT_BUF_LEN )){
   if (Buffer[4]==32){
    if (!Timestat){
     Delay = Orginaldelay;
    // printf( "Start Timer\n");
     pthread_create (&Tim, NULL, Timer, NULL);
     Timestat=1;
    }  
   }
  }
 }
}


